﻿@using Google.Authenticator
@using System.Web
@{
    ViewData["Title"] = "Settings";
    SetupCode SetupCode = ViewBag.SetupCode;
    bool HasTwoFactorAuth = ViewBag.HasTwoFactorAuth;
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="card-header flex-wrap border-0 p-0">
                <div class="card-title mb-0">
                    <div class="d-flex justify-content-between">
                        <div>
                            <h3 class="card-label text-primary">
                                Security Settings
                            </h3>
                        </div>
                        <div>
                            <a onclick="goBack()" class="btn btn-sm btn-icon btn-outline-primary btn-hover-light-primary btn-circle" data-toggle="tooltip" title="Go Back">
                                <i class="fas fa-arrow-left"></i>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="d-flex">
                <div class="w-50">
                    <form action="/home/savetwofactorauth" class="form" id="frm-two-factor-auth" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormComplete2StepVerification">
                        <div class="card-body pl-0 pt-3">
                            <div class="row">
                                <div class="col-xl-8">
                                    <div class="form-group">
                                        <label>Email</label>
                                        <input class="form-control form-control-lg" value="@HttpUtility.UrlDecode(SetupCode.Account)" disabled>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="d-flex">
                                    <div class="align-self-center mr-2">
                                        <span class="switch switch-icon switch-sm switch-custom">
                                            <label>
                                                <input id="TwoFactorAuth" type="checkbox" name="TwoFactorAuth" checked="@(HasTwoFactorAuth ? "checked" : null)" value="true" />
                                                <span></span>
                                            </label>
                                        </span>
                                    </div>
                                    <label class="col-form-label switch-label">
                                        2-Step Verification
                                    </label>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-xl-8">
                                    <div class="form-group">
                                        <label>Setup Key</label>
                                        <textarea id="SecurityKey" class="form-control form-control-lg" rows="2" disabled style="resize:none">@SetupCode.ManualEntryKey</textarea>
                                    </div>
                                    <div class="form-group">
                                        <label>Verification Code</label>
                                        <input class="form-control form-control-lg required" id="VerificationCode" name="VerificationCode" maxlength="6">
                                    </div>
                                </div>
                                <div class="col-xl-4" id="QrCode-container">
                                    <img src="@SetupCode.QrCodeSetupImageUrl" />
                                </div>
                            </div>
                            <button class="btn btn-primary font-weight-bold px-6 py-2" id="btn_submit_2step">
                                <i class="la la-save icon-lg"></i>Save
                            </button>
                        </div>
                    </form>
                </div>
                <div class="col-md-6 bg-light-primary mt-3 p-8" id="two-factor-auth-help">
                    <partial name="TwoFactorAuthHelp" />
                </div>
            </div>
        </div>
    </div>
</div>
@section scripts{
    <script>
        $("#frm-two-factor-auth").validate({
            messages: {
                VerificationCode: "Provide Verification Code"
            }
        });
        var hasTwoFactorAuth = '@HasTwoFactorAuth' == "True";
        $("#TwoFactorAuth").change(function() {
            var hasTwoFactorAuth = $(this).is(":checked");
            showHideTwoFactorAuth(hasTwoFactorAuth);
            $("#btn_submit_2step").prop("disabled", false);
        });
        var showHideTwoFactorAuth = function(hasTwoFactorAuth, init) {
            $("#SecurityKey").closest(".form-group").addClass("d-none");
            $("#VerificationCode").closest(".form-group").addClass("d-none");
            $("#QrCode-container").addClass("d-none");
            $("#two-factor-auth-help").addClass("d-none");
            if (hasTwoFactorAuth) {
                $("#SecurityKey").closest(".form-group").removeClass("d-none");
                $("#QrCode-container").removeClass("d-none");
                $("#two-factor-auth-help").removeClass("d-none");
                if (init)
                    $("#btn_submit_2step").prop("disabled", true);
                else
                    $("#VerificationCode").val(null).closest(".form-group").removeClass("d-none");
            }
            else
                $("#btn_submit_2step").prop("disabled", true);
        }
        showHideTwoFactorAuth(hasTwoFactorAuth, true);
        var onFormComplete2StepVerification = function(response) {
            $(".alert").remove();
            var id = $(this).find(":submit").attr('id');
            var btn = KTUtil.getById(id);
            var frm_id = $(this).attr('id');
            var responseObj = JSON.parse(response.responseText);
            if (responseObj.success == false)
                _showFormMessage(frm_id, "danger", responseObj.message, "fas fa-exclamation-triangle");
            else {
                $("#TwoFactorAuth").prop("checked", responseObj.data.twoFactorAuth);
                var hasTwoFactorAuth = $("#TwoFactorAuth").is(":checked");
                showHideTwoFactorAuth(hasTwoFactorAuth, true);
                toastr.options = toastrOptions;
                if (hasTwoFactorAuth)
                    toastr.success(responseObj.message);
                else
                    toastr.warning(responseObj.message);
                if (responseObj.redirectUrl)
                    setTimeout(function() {
                        window.location.href = responseObj.redirectUrl;
                    }, 3000);
            }
            KTUtil.btnRelease(btn);
            $("#btn_submit_2step").prop("disabled", true);
        };
    </script>
}